package militaryrental;

import java.util.*;
import oracle.jdbc.driver.OracleDriver;
import java.sql.*;

public class Locations {

    Connection con = null;

    /* Our DB connection - change accordingly */

    //private String dbName  = "jdbc:oracle:thin:konrad/A@10.0.0.4:1521:darnok";
    private String dbName  = "jdbc:oracle:thin:krzeszut/konrad15@cook.cs.uno.edu:1521:cs4125";
    /* Our SQL statements */

    /* selects all attributes from the armory with a condition where the name must match a specific entry */
    private String selectByName = "select * from armory where name = ?";

    /* selects all armories */
    private String selectAll = "select * from armory";


    private PreparedStatement prepAll = null;
    private PreparedStatement prepByName = null;

    /**
     * Init the object
     */
    public Locations() {
	
	this.initConnection();
    }
   
    /**
     * Retrieves a ArrayList of Location object where each object has
     * specific information about the location
     */
    public Collection getLocations() {
	
	if (locations != null)
	    return locations;
	
	locations = new ArrayList();
	
	populate();
	
	Collections.sort(locations);
	return locations;    
    }           

    /**
     * Retrieve information about a specific Location
     *
     * return:
     *  != null
     */
    public Location getLocationByName(String name) {

	Location loc = null;
	if (con == null) 
	    initConnection();
	
        try {
	    prepByName.setString(1,name);
	    ResultSet rs = prepByName.executeQuery();
	    while (rs.next()) {
		System.out.println("Found "+rs.getString(1)+" matching "+name);
		loc = new Location(rs.getString(1), rs.getString(2), rs.getString(3), rs.getString(4), rs.getString(5));                        
	    }
	} catch (SQLException ex) {
	    ex.printStackTrace();
	}
	return loc;	
    }

    /**
     * Populate our internal listing of inromation.
     */
    private void populate() {
	
	if (con == null) 
	    initConnection();	
	
        try {
	    ResultSet rs = prepAll.executeQuery();
	    while (rs.next()) {
		System.out.println("["+rs.getString(1)+"]");	 
		Location bd = new Location(rs.getString(1), rs.getString(2), rs.getString(3), rs.getString(4), rs.getString(5));
		locations.add(bd);
	    }
	} catch (SQLException ex) {
	    ex.printStackTrace();
	    
	}
    }  
    
    
    /**
     * Makes the DB connection and setups up the SQL statements
     */
    private void initConnection () {
	
	try {
	    Class.forName("oracle.jdbc.driver.OracleDriver");
	} catch (Exception e) { e.printStackTrace(); }
      
	try {
	    con = DriverManager.getConnection (dbName);
	    prepByName = con.prepareStatement(selectByName);
	    prepAll    = con.prepareStatement(selectAll);
	} catch (SQLException e) {
	    e.printStackTrace();
	}
    }
    
    private ArrayList locations;
    
}
