package militaryrental;

public class ReservationStatus {

    /**
     * Status of the reservation.
     *
     * require:
     *  isReserved = true || false
     *  id >= 0.00
     *  msg != null
     */
    public ReservationStatus(boolean isReserved, long id, String msg) {

	this.reserved = isReserved;
	this.id = id;
	this.msg = msg;
    }

    /**
     * Has the reservation been succesfully allocated
     */
    public boolean isReserved() {

	return reserved;
    }

    /**
     * The confirmation number for the reservation.
     */
    public long getConfirmationId() {

	return id;
    }

    /**
     * The reason why the reservation wasn't completed.
     */
    public String getErrorMsg() {

	return msg;

    }

    private String msg;
    private long id;
    private boolean reserved; 
}
